import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

public class BubbleWorld extends World
{
//Hier ist eine ArrayList die definiert welche B?lle wo stehen sollen und welche Farbe sie tragen sollen
    private String[] maps =
        {"7  7  7  7   7   6   6   7   7   7   5  7  7   7  6  6  7  7   7   7  7  7 ",
            
        "4  3   2   2   4   3   5   4   4   2   3   3   4   5   4   4   2   2   4   2   2   " +
        "  -  -   4   5   5   3   4   2   4   3   3   2   5   4   4   4   2   5   2   5  -  -" +
        "-   -   -   -   5   -   -   -  3   -   -   -   -   -   -   2   -   -   -   " +
        "  -   -   -   -    ",
            
        "-  -   -   3   -   3   -   3   -   -   3   -   3   -   3   -   3   -   -   3   -   3"+
        "2  2   4     4   -   5   -   5   4   3   2   1   1   2   -   -   -   4   4   2   -"+
        "- -   -    3   3   -   3   -   3   -   2   1   3   -3  -   2   -   3   3   3   2   -"+
        ""+
        ""+
        ""+
        ""+
        ""
        ,
        "-  -   -   3   -   3   -   3   -   -   3   -   3   -   3   -   3   -   -   3   -   3"+
        "2  2   4     4   -   5   -   5   4   3   2   1   1   2   -   -   -   4   4   2   -"+
        "- -   -    3   3   -   3   -   3   -   2   1   3   -3  -   2   -   3   3   3   2   -"+
        "- -   -    5   3   -   6   -   3   -   4   4   6   -6  -   2   -   4   3   6   6   -"+
        ""+
        ""+
        ""+
        ""
        ,
         "-  -   -   3   -   3   -   3   -   -   3   -   3   -   3   -   3   -   -   3   -   3"+
        "2  2   4     7   -   7   -   5   4   3   2   1   1   2   -   -   -   4   4   2   -"+
        "- -   -    3   3   -   3   -   3   -   2   1   3   -3  -   2   -   3   3   3   2   -"+
        "- -   -    5   3   -   6   -   3   -   4   4   6   -6  -   2   -   4   3   6   6   -"+
        "2  2   4     7   -   7   -   5   4   3   2   1   1   2   -   -   -   4   4   2   -"+
        "- -   -    5   4   -   6   -   3   -   1   4   6   -6  -   2   -   4   3   6   6   -"+
        "- 1   1    5   2   -   2   -   3   -   1   5   6   -7  -   2   -   4   3   6   6   -"+
        ""
        ,
         "-  -   -   3   -   3   -   3   -   -   3   -   3   -   3   -   3   -   -   3   -   3"+
        "2  2   4     7   -   7   -   5   4   3   2   1   1   2   -   -   -   4   4   2   -"+
        "- -   -    3   3   -   3   -   3   -   2   1   3   -3  -   2   -   3   3   3   2   -"+
        "- -   -    5   3   -   6   -   3   -   4   4   6   -6  -   2   -   4   3   6   6   -"+
        "2  2   4     7   -   7   -   5   4   3   2   1   1   2   -   -   -   4   4   2   -"+
        "- -   -    5   4   -   6   -   3   -   1   4   6   -6  -   2   -   4   3   6   6   -"+
        "- 1   1    5   2   -   2   -   3   -   1   5   6   -7  -   2   -   4   3   6   6   -"+
        ""
        ,
      
    };
    
    private Map map;
    public Kanone kanone;
    public Kanone2 kanonezwei;
    public PunkteStandAnzeige PS;
    

    
    private int level = 0;
    private boolean flag = true;
    private int levelNum = 5;
    
    public BubbleWorld()
    {    
        
        super(700, 600, 1); 
        PS = new PunkteStandAnzeige("Schuesse: 0");
        // Die Geschwindigkeit wird auf das Maximum aufgedreht damit die B?lle eine flssige Bewegung haben 
        Greenfoot.setSpeed(100);
        
        // Hier l?d es den Karte des Spiels
        map = new Map(this, maps[0]);
        
        // Hier werden die zu benutzenden B?lle geladen, also berprft welche genutzt werden k?nnen
        map.updateAllowedBallTypes();
        
        Start start = new Start();
        Greenfoot.setWorld(start);
       
        bevoelkereWelt();
    }
    
    public Map getMap()
    {
        return map;
    }
    
    public void gameOver()
{
Greenfoot.stop();
}

    public void act()
    {

        // Update der Karte
        map.update();
        
        // Hier wird definiert was passiert wenn der Spieler das Spiel gewinnt
        if (map.hasWon()) {
            if (numberOfObjects() < 4) {
                
                flag = true;
                
                level++;
                if (level < levelNum) {
                    map = new Map(this, maps[level]);
                    map.updateAllowedBallTypes();
                    kanone.prepareBall();
                } else
                    Greenfoot.stop();
                
            } else if (flag) {
                    PS = new PunkteStandAnzeige("Map " + (level + 1) + "  Clear!");
                    addObject(PS, getWidth() / 2, getHeight() / 2);
                    flag = false;
                    
                    // Ton
                    Greenfoot.playSound("cleared.wav");
            }
        }
       
   

    }
public void bevoelkereWelt()
    {
        addObject(PS, 100, 40);
        Kanone kanone = new Kanone(PS);
        Kanone2 kanonezwei = new Kanone2();
        addObject(kanone, 200, 700);
        addObject(kanonezwei, 500, 700);
    }
}
