import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)


public class Objekte extends Actor
{
    private long altZeit;
    protected long ticks = 0;

    public void act() 
    {
        long newZeit = System.nanoTime();
        
        // Hier wrd die Zeit in Einheiten umgeformt
        double deltaTime = (newZeit-altZeit) / 10000000.0;

        // Hier wird der erste Tick definiert. (1/100 s)
        if(ticks == 0)
        {
            deltaTime = 1;
        }

        // Falls es zu verlangsamung des Spiels kommt wird die Zeit ein bisschen runtergesetzt auf: (1/25 s).
        if(deltaTime >= 4)
        {
            deltaTime = 4;
        }
        
        // Speicherung der Zeit
        altZeit = newZeit;

        // Aufruf der Unterklasse
        act(deltaTime);

        // erh?hung der Ticks
        ticks++;
    }    
    
    // Unterklassen sollten dieses Ueberscheiben
    public void act(double deltaTime)
    {
    }
}
